dofile("script/object.lua")

local function Fade(from, to, duration, callback, tile, depth, occTile)	
	depth = depth or 1
	occTile = occTile or 'f'
	local step = (to - from) / (10 * duration)
	tile = tile or Occlusion.put(occTile, -400, -240, depth,
				     { size = { 800, 480 } },
				     camera.ptr)
	
	local function Fade()
		if (step > 0 and from <= to) 
		or (step < 0 and from >= to) then
			local alpha = math.min(1, math.max(0, from))
			local color = { r = 1, g = 1, b = 1, a = alpha }
			eapi.SetAttributes(tile, { color = color })
			eapi.AddTimer(staticBody, 0.1, Fade)
			from = from + step
		else 
			if callback then callback(tile) end
		end
	end

	Fade()
end

effects = {
	Fade = Fade,
}
return effects
